(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory(require("express"), require("socket.io"), require("multer"), require("body-parser"), require("crypto"), require("fs"), require("mkdirp"), require("child_process"), require("axios"), require("socket.io-client"));
	else if(typeof define === 'function' && define.amd)
		define("starboard", ["express", "socket.io", "multer", "body-parser", "crypto", "fs", "mkdirp", "child_process", "axios", "socket.io-client"], factory);
	else if(typeof exports === 'object')
		exports["starboard"] = factory(require("express"), require("socket.io"), require("multer"), require("body-parser"), require("crypto"), require("fs"), require("mkdirp"), require("child_process"), require("axios"), require("socket.io-client"));
	else
		root["starboard"] = factory(root["express"], root["socket.io"], root["multer"], root["body-parser"], root["crypto"], root["fs"], root["mkdirp"], root["child_process"], root["axios"], root["socket.io-client"]);
})(this, function(__WEBPACK_EXTERNAL_MODULE_2__, __WEBPACK_EXTERNAL_MODULE_3__, __WEBPACK_EXTERNAL_MODULE_4__, __WEBPACK_EXTERNAL_MODULE_5__, __WEBPACK_EXTERNAL_MODULE_9__, __WEBPACK_EXTERNAL_MODULE_11__, __WEBPACK_EXTERNAL_MODULE_35__, __WEBPACK_EXTERNAL_MODULE_36__, __WEBPACK_EXTERNAL_MODULE_42__, __WEBPACK_EXTERNAL_MODULE_43__) {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};

/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {

/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId])
/******/ 			return installedModules[moduleId].exports;

/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			exports: {},
/******/ 			id: moduleId,
/******/ 			loaded: false
/******/ 		};

/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);

/******/ 		// Flag the module as loaded
/******/ 		module.loaded = true;

/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}


/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;

/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;

/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "/";

/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(0);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ (function(module, exports, __webpack_require__) {

	'use strict';

	exports.Starboard = __webpack_require__(1).default;
	exports.CurrentState = __webpack_require__(17).default;
	exports.GitEventStorage = __webpack_require__(34).default;
	exports.MemoryEventStorage = __webpack_require__(37).default;
	exports.MemoryEventStorageFactory = __webpack_require__(38).default;
	exports.ServerEventStorage = __webpack_require__(41).default;
	exports.SettingsRepository = __webpack_require__(44).default;
	exports.CardsRepository = __webpack_require__(16).default;
	exports.ColumnsRepository = __webpack_require__(45).default;
	exports.CommentsRepository = __webpack_require__(14).default;
	exports.UsersRepository = __webpack_require__(46).default;
	exports.eventDefinitions = __webpack_require__(15);

/***/ }),
/* 1 */
/***/ (function(module, exports, __webpack_require__) {

	'use strict';

	Object.defineProperty(exports, "__esModule", {
	  value: true
	});

	var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }(); /* eslint-disable no-multi-spaces */

	var _express = __webpack_require__(2);

	var _express2 = _interopRequireDefault(_express);

	var _socket = __webpack_require__(3);

	var _socket2 = _interopRequireDefault(_socket);

	var _multer = __webpack_require__(4);

	var _multer2 = _interopRequireDefault(_multer);

	var _bodyParser = __webpack_require__(5);

	var _bodyParser2 = _interopRequireDefault(_bodyParser);

	var _storeFileUsecase = __webpack_require__(6);

	var _storeFileUsecase2 = _interopRequireDefault(_storeFileUsecase);

	var _cleanFilesUsecase = __webpack_require__(13);

	var _cleanFilesUsecase2 = _interopRequireDefault(_cleanFilesUsecase);

	var _currentState = __webpack_require__(17);

	var _currentState2 = _interopRequireDefault(_currentState);

	var _allowEveryoneAuth = __webpack_require__(32);

	var _allowEveryoneAuth2 = _interopRequireDefault(_allowEveryoneAuth);

	var _nullLogger = __webpack_require__(33);

	var _nullLogger2 = _interopRequireDefault(_nullLogger);

	var _utils = __webpack_require__(12);

	var _eventDefinitions = __webpack_require__(15);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

	var Server = function () {
	  function Server(params) {
	    _classCallCheck(this, Server);

	    this.eventStorage = params.eventStorage || (0, _utils.hasToBeSet)('eventStorage');
	    this.serverPort = params.port || 9000;
	    this.uploadsDir = params.uploadsDir || '.tmp/tmpUploads/';
	    this.logger = params.logger || new _nullLogger2.default();
	    this.auth = params.auth || new _allowEveryoneAuth2.default();
	    this.noBanner = params.noBanner || false;

	    this.server = null;
	    this.sockets = [];
	    this.currentState = new _currentState2.default({ eventSource: this.eventStorage });
	    this.storeFileUsecase = new _storeFileUsecase2.default(this.currentState, { storedFilesDir: this.uploadsDir });
	    this.cleanFilesUsecase = new _cleanFilesUsecase2.default(this.currentState, {
	      pathToStorage: this.uploadsDir,
	      fileNamePrefix: '/attachments/'
	    });
	  }

	  _createClass(Server, [{
	    key: 'displayBanner',
	    value: function displayBanner() {
	      // eslint-disable-next-line no-console
	      console.log('\n    |\n    | Starting Starboard...\n    | ' + this.eventStorage.welcomeInfo() + '\n    | ' + this.auth.welcomeInfo() + '\n    |\n    | Board available at: http://localhost:' + this.serverPort + '/\n    |\n    ');
	    }
	  }, {
	    key: 'start',
	    value: function start() {
	      var _this = this;

	      if (!this.noBanner) {
	        this.displayBanner();
	      }

	      var app = (0, _express2.default)();
	      var server = app.listen(this.serverPort);
	      var io = (0, _socket2.default)(server);
	      var upload = (0, _multer2.default)({ dest: this.uploadsDir });

	      this.server = server;

	      app.use(_express2.default.static(__dirname + '/frontend/'));
	      app.use(_bodyParser2.default.json());

	      // ----------------- http -----------------
	      app.get('/attachments/:fileName', function (req, res) {
	        res.sendFile(req.params.fileName, {
	          dotfiles: 'deny',
	          root: _this.uploadsDir
	        });
	      });

	      app.post('/attachments/', upload.single('attachment'), function (req, res) {
	        _this.storeFileUsecase.addFile(req.file).then(function (fileName) {
	          res.send({ attachmentUrl: '/attachments/' + fileName });
	        });
	      });

	      app.post('/login/', function (req, res) {
	        var email = req.body.email;
	        var password = req.body.password;
	        _this.auth.grantAccessWithCredentials(email, password).then(function (authData) {
	          res.send({ userId: authData.userId, token: authData.token });
	        }).catch(function () {
	          res.send(403, 'access denied');
	        });
	      });

	      // ----------- websockets utils -----------
	      var allClientsNotifier = {
	        onNewEvent: function onNewEvent(newEvent) {
	          _this.sockets.forEach(function (socket) {
	            socket.emit('newEvent', newEvent);
	          });
	        }
	      };
	      this.eventStorage.addObserver(allClientsNotifier);

	      // -------------- webSockets --------------
	      io.on('connection', function (socket) {
	        _this.auth.grantAccess(socket.handshake.query.token).then(function () {
	          _this.configureSocket(socket);
	          socket.emit('accessGranted');
	        }).catch(function () {
	          socket.emit('accessDenied');
	          socket.disconnect();
	        });
	      });
	    }
	  }, {
	    key: 'stop',
	    value: function stop() {
	      this.server.close();
	      this.server = null;
	    }

	    // private

	  }, {
	    key: 'configureSocket',
	    value: function configureSocket(socket) {
	      var _this2 = this;

	      this.sockets.push(socket);
	      socket.on('disconnect', function () {
	        _this2.sockets.splice(_this2.sockets.indexOf(socket), 1);
	      });

	      socket.on('addEvent', function (event, sendBack) {
	        _this2.auth.allowEvent(event, socket.handshake.query.token).then(function () {
	          _this2.cleanFilesUsecase.cleanWhenNeeded(event);
	          sendBack(event);
	          _this2.eventStorage.addEvent(event);
	        }).catch(function () {
	          sendBack((0, _eventDefinitions.permissionDeniedEvent)(event));
	        });
	      });

	      socket.on('getAllPastEvents', function (sendBack) {
	        _this2.eventStorage.allPastEvents().then(function (events) {
	          sendBack(events);
	        });
	      });
	    }
	  }]);

	  return Server;
	}();

	exports.default = Server;

/***/ }),
/* 2 */
/***/ (function(module, exports) {

	module.exports = require("express");

/***/ }),
/* 3 */
/***/ (function(module, exports) {

	module.exports = require("socket.io");

/***/ }),
/* 4 */
/***/ (function(module, exports) {

	module.exports = require("multer");

/***/ }),
/* 5 */
/***/ (function(module, exports) {

	module.exports = require("body-parser");

/***/ }),
/* 6 */
/***/ (function(module, exports, __webpack_require__) {

	'use strict';

	Object.defineProperty(exports, "__esModule", {
	  value: true
	});

	var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

	var _v = __webpack_require__(7);

	var _v2 = _interopRequireDefault(_v);

	var _fs = __webpack_require__(11);

	var _fs2 = _interopRequireDefault(_fs);

	var _utils = __webpack_require__(12);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

	var StoreFileUsecase = function () {
	  function StoreFileUsecase(eventStorage) {
	    var params = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

	    _classCallCheck(this, StoreFileUsecase);

	    this.eventStorage = eventStorage;
	    this.storedFilesDir = params.storedFilesDir || (0, _utils.hasToBeSet)('storedFilesDir');
	  }

	  _createClass(StoreFileUsecase, [{
	    key: 'addFile',
	    value: function addFile(multerFile) {
	      var _this = this;

	      var originalFileName = multerFile.originalname;
	      var originalFilePath = multerFile.path;
	      var uniqueFileName = (0, _v2.default)() + '---' + originalFileName;
	      var uniqueFilePath = '' + this.storedFilesDir + uniqueFileName;

	      return new Promise(function (resolve, reject) {
	        _fs2.default.rename(originalFilePath, uniqueFilePath, function (err) {
	          return err ? reject(err) : resolve();
	        });
	      }).then(function () {
	        return _this.eventStorage.addFile(uniqueFileName);
	      });
	    }
	  }]);

	  return StoreFileUsecase;
	}();

	exports.default = StoreFileUsecase;

/***/ }),
/* 7 */
/***/ (function(module, exports, __webpack_require__) {

	'use strict';

	var rng = __webpack_require__(8);
	var bytesToUuid = __webpack_require__(10);

	function v4(options, buf, offset) {
	  var i = buf && offset || 0;

	  if (typeof options == 'string') {
	    buf = options == 'binary' ? new Array(16) : null;
	    options = null;
	  }
	  options = options || {};

	  var rnds = options.random || (options.rng || rng)();

	  // Per 4.4, set bits for version and `clock_seq_hi_and_reserved`
	  rnds[6] = rnds[6] & 0x0f | 0x40;
	  rnds[8] = rnds[8] & 0x3f | 0x80;

	  // Copy bytes to buffer, if provided
	  if (buf) {
	    for (var ii = 0; ii < 16; ++ii) {
	      buf[i + ii] = rnds[ii];
	    }
	  }

	  return buf || bytesToUuid(rnds);
	}

	module.exports = v4;

/***/ }),
/* 8 */
/***/ (function(module, exports, __webpack_require__) {

	'use strict';

	// Unique ID creation requires a high quality random # generator.  In node.js
	// this is prett straight-forward - we use the crypto API.

	var rb = __webpack_require__(9).randomBytes;

	function rng() {
	  return rb(16);
	};

	module.exports = rng;

/***/ }),
/* 9 */
/***/ (function(module, exports) {

	module.exports = require("crypto");

/***/ }),
/* 10 */
/***/ (function(module, exports) {

	'use strict';

	/**
	 * Convert array of 16 byte values to UUID string format of the form:
	 * XXXXXXXX-XXXX-XXXX-XXXX-XXXX-XXXXXXXXXXXX
	 */
	var byteToHex = [];
	for (var i = 0; i < 256; ++i) {
	  byteToHex[i] = (i + 0x100).toString(16).substr(1);
	}

	function bytesToUuid(buf, offset) {
	  var i = offset || 0;
	  var bth = byteToHex;
	  return bth[buf[i++]] + bth[buf[i++]] + bth[buf[i++]] + bth[buf[i++]] + '-' + bth[buf[i++]] + bth[buf[i++]] + '-' + bth[buf[i++]] + bth[buf[i++]] + '-' + bth[buf[i++]] + bth[buf[i++]] + '-' + bth[buf[i++]] + bth[buf[i++]] + bth[buf[i++]] + bth[buf[i++]] + bth[buf[i++]] + bth[buf[i++]];
	}

	module.exports = bytesToUuid;

/***/ }),
/* 11 */
/***/ (function(module, exports) {

	module.exports = require("fs");

/***/ }),
/* 12 */
/***/ (function(module, exports) {

	"use strict";

	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	exports.currentTimestamp = currentTimestamp;
	exports.formattedDate = formattedDate;
	exports.hasToBeSet = hasToBeSet;
	function currentTimestamp() {
	  return Math.floor(Date.now() / 1000);
	}

	function formattedDate(timestamp) {
	  function pad(x) {
	    return ("0" + x).slice(-2);
	  }

	  var d = new Date(timestamp * 1000);
	  var hours = pad(d.getHours());
	  var minutes = pad(d.getMinutes());
	  var seconds = pad(d.getSeconds());
	  var day = pad(d.getDate());
	  var month = pad(d.getMonth() + 1);
	  var year = pad(d.getYear());
	  return hours + ":" + minutes + ":" + seconds + " " + day + "/" + month + "/" + year;
	}

	function hasToBeSet(key) {
	  throw new Error(key + " has to be set");
	}

/***/ }),
/* 13 */
/***/ (function(module, exports, __webpack_require__) {

	'use strict';

	Object.defineProperty(exports, "__esModule", {
	  value: true
	});

	var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

	var _fs = __webpack_require__(11);

	var _fs2 = _interopRequireDefault(_fs);

	var _commentsRepository = __webpack_require__(14);

	var _commentsRepository2 = _interopRequireDefault(_commentsRepository);

	var _cardsRepository = __webpack_require__(16);

	var _cardsRepository2 = _interopRequireDefault(_cardsRepository);

	var _utils = __webpack_require__(12);

	var _eventDefinitions = __webpack_require__(15);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

	var CleanFilesUsecase = function () {
	  function CleanFilesUsecase(currentState) {
	    var params = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

	    _classCallCheck(this, CleanFilesUsecase);

	    this.currentState = currentState;
	    this.fileNamePrefix = params.fileNamePrefix || '';
	    this.pathToStorage = params.pathToStorage || (0, _utils.hasToBeSet)('pathToStorage');
	    this.commentsRepo = new _commentsRepository2.default(this.currentState);
	    this.cardsRepo = new _cardsRepository2.default(this.currentState);
	  }

	  _createClass(CleanFilesUsecase, [{
	    key: 'cleanWhenNeeded',
	    value: function cleanWhenNeeded(event) {
	      var t = event.type;
	      if (t === _eventDefinitions.columnRemovedEventType) return this.removeColumnRelatedFiles(event.data.columnId);
	      if (t === _eventDefinitions.cardRemovedEventType) return this.removeCardRelatedFiles(event.data.cardId);
	      if (t === _eventDefinitions.commentRemovedEventType) return this.removeCommentRelatedFiles(event.data.commentId);
	      return Promise.resolve();
	    }

	    // private

	  }, {
	    key: 'removeColumnRelatedFiles',
	    value: function removeColumnRelatedFiles(columnId) {
	      var _this = this;

	      var cards = this.cardsRepo.cardsSortedByPosition(columnId);
	      var promises = cards.map(function (card) {
	        return _this.removeCardRelatedFiles(card.id);
	      });
	      return Promise.all(promises);
	    }
	  }, {
	    key: 'removeCardRelatedFiles',
	    value: function removeCardRelatedFiles(cardId) {
	      var _this2 = this;

	      var comments = this.commentsRepo.commentsForCard(cardId);
	      var promises = comments.map(function (comment) {
	        return _this2.removeAttachment(comment);
	      });
	      return Promise.all(promises);
	    }
	  }, {
	    key: 'removeCommentRelatedFiles',
	    value: function removeCommentRelatedFiles(commentId) {
	      var comment = this.commentsRepo.get(commentId);
	      return this.removeAttachment(comment);
	    }
	  }, {
	    key: 'removeAttachment',
	    value: function removeAttachment(comment) {
	      var _this3 = this;

	      if (!comment.attachment) return Promise.resolve();

	      var filePublicUrl = comment.attachment.dataUrl;
	      var fileName = filePublicUrl.replace(this.fileNamePrefix, '');

	      return this.removeFile(fileName).then(function () {
	        _this3.currentState.removeFile(fileName);
	      });
	    }
	  }, {
	    key: 'removeFile',
	    value: function removeFile(fileName) {
	      var filePath = this.pathToStorage + '/' + fileName;
	      return new Promise(function (resolve, reject) {
	        _fs2.default.unlink(filePath, function (err) {
	          return err ? reject(err) : resolve();
	        });
	      });
	    }
	  }]);

	  return CleanFilesUsecase;
	}();

	exports.default = CleanFilesUsecase;

/***/ }),
/* 14 */
/***/ (function(module, exports, __webpack_require__) {

	'use strict';

	Object.defineProperty(exports, "__esModule", {
	  value: true
	});

	var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

	var _eventDefinitions = __webpack_require__(15);

	function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

	var CommentsRepository = function () {
	  function CommentsRepository(stateManager) {
	    _classCallCheck(this, CommentsRepository);

	    this.stateManager = stateManager;
	  }

	  _createClass(CommentsRepository, [{
	    key: 'get',
	    value: function get(id) {
	      var bucket = this.stateManager.bucket('comments');
	      return bucket.filter(function (c) {
	        return c.id === id;
	      })[0];
	    }
	  }, {
	    key: 'commentsCountForCard',
	    value: function commentsCountForCard(cardId) {
	      var bucket = this.stateManager.bucket('comments');
	      return bucket.filter(function (c) {
	        return c.cardId === cardId;
	      }).length;
	    }
	  }, {
	    key: 'commentsForCard',
	    value: function commentsForCard(cardId) {
	      var bucket = this.stateManager.bucket('comments');
	      return bucket.filter(function (c) {
	        return c.cardId === cardId;
	      }).sort(function (c1, c2) {
	        return c2.createdAt - c1.createdAt;
	      });
	    }
	  }, {
	    key: 'addComment',
	    value: function addComment(cardId, params) {
	      var attachment = params.attachment;

	      if (attachment) {
	        return this.addCommentWithAttachment(cardId, params);
	      }

	      return this.addCommentWithoutAttachment(cardId, params);
	    }
	  }, {
	    key: 'updateComment',
	    value: function updateComment(id, changes) {
	      var event = (0, _eventDefinitions.commentUpdatedEvent)(id, changes);
	      return this.stateManager.addEvent(event);
	    }
	  }, {
	    key: 'removeComment',
	    value: function removeComment(commentId) {
	      var event = (0, _eventDefinitions.commentRemovedEvent)(commentId);
	      return this.stateManager.addEvent(event);
	    }

	    // private

	  }, {
	    key: 'addCommentWithAttachment',
	    value: function addCommentWithAttachment(cardId, params) {
	      var _this = this;

	      var content = params.content,
	          attachment = params.attachment,
	          authorId = params.authorId;


	      return this.stateManager.addFile(attachment.blob).then(function (attachmentUrl) {
	        var event = (0, _eventDefinitions.commentAddedEvent)(cardId, {
	          content: content,
	          authorId: authorId,
	          attachmentName: attachment.name,
	          attachmentSize: attachment.size,
	          attachmentType: attachment.type,
	          attachmentUrl: attachmentUrl
	        });
	        return _this.stateManager.addEvent(event);
	      });
	    }
	  }, {
	    key: 'addCommentWithoutAttachment',
	    value: function addCommentWithoutAttachment(cardId, params) {
	      var content = params.content,
	          authorId = params.authorId;


	      var event = (0, _eventDefinitions.commentAddedEvent)(cardId, {
	        content: content,
	        authorId: authorId
	      });
	      return this.stateManager.addEvent(event);
	    }
	  }]);

	  return CommentsRepository;
	}();

	exports.default = CommentsRepository;

/***/ }),
/* 15 */
/***/ (function(module, exports, __webpack_require__) {

	'use strict';

	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	exports.userUpdatedEventType = exports.settingsUpdatedEventType = exports.fileRemovedEventType = exports.fileAddedEventType = exports.commentRemovedEventType = exports.commentUpdatedEventType = exports.commentAddedEventType = exports.columnRemovedEventType = exports.columnUpdatedEventType = exports.columnAddedEventType = exports.cardRemovedEventType = exports.cardLabelUpdatedEventType = exports.cardUpdatedEventType = exports.cardAddedEventType = exports.permissionDeniedEventType = exports.noopEventType = undefined;
	exports.noopEvent = noopEvent;
	exports.permissionDeniedEvent = permissionDeniedEvent;
	exports.cardAddedEvent = cardAddedEvent;
	exports.cardUpdatedEvent = cardUpdatedEvent;
	exports.cardLabelUpdatedEvent = cardLabelUpdatedEvent;
	exports.cardRemovedEvent = cardRemovedEvent;
	exports.columnAddedEvent = columnAddedEvent;
	exports.columnUpdatedEvent = columnUpdatedEvent;
	exports.columnRemovedEvent = columnRemovedEvent;
	exports.commentAddedEvent = commentAddedEvent;
	exports.commentUpdatedEvent = commentUpdatedEvent;
	exports.commentRemovedEvent = commentRemovedEvent;
	exports.fileAddedEvent = fileAddedEvent;
	exports.fileRemovedEvent = fileRemovedEvent;
	exports.settingsUpdatedEvent = settingsUpdatedEvent;
	exports.userUpdatedEvent = userUpdatedEvent;

	var _v = __webpack_require__(7);

	var _v2 = _interopRequireDefault(_v);

	var _utils = __webpack_require__(12);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	var noopEventType = exports.noopEventType = 'NOOP';
	function noopEvent() {
	  return { type: noopEventType, id: (0, _v2.default)() };
	}

	var permissionDeniedEventType = exports.permissionDeniedEventType = 'PERMISSION_DENIED';
	function permissionDeniedEvent(originalEvent) {
	  return {
	    type: permissionDeniedEventType,
	    originalEvent: originalEvent,
	    id: (0, _v2.default)()
	  };
	}

	var cardAddedEventType = exports.cardAddedEventType = 'CARD_ADDED';
	function cardAddedEvent(params) {
	  var columnId = params.columnId,
	      position = params.position,
	      title = params.title;

	  return {
	    type: cardAddedEventType,
	    data: {
	      id: (0, _v2.default)(),
	      columnId: columnId,
	      position: position,
	      title: title,
	      description: '',
	      createdAt: (0, _utils.currentTimestamp)()
	    },
	    id: (0, _v2.default)()
	  };
	}

	var cardUpdatedEventType = exports.cardUpdatedEventType = 'CARD_UPDATED';
	function cardUpdatedEvent(cardId, changes) {
	  return {
	    type: cardUpdatedEventType,
	    data: {
	      cardId: cardId,
	      changes: changes
	    },
	    id: (0, _v2.default)()
	  };
	}

	var cardLabelUpdatedEventType = exports.cardLabelUpdatedEventType = 'CARD_LABEL_UPDATED';
	function cardLabelUpdatedEvent(cardId, label, shouldBeSet) {
	  return {
	    type: cardLabelUpdatedEventType,
	    data: {
	      cardId: cardId,
	      label: label,
	      set: shouldBeSet
	    },
	    id: (0, _v2.default)()
	  };
	}

	var cardRemovedEventType = exports.cardRemovedEventType = 'CARD_REMOVED';
	function cardRemovedEvent(cardId) {
	  return {
	    type: cardRemovedEventType,
	    data: { cardId: cardId },
	    id: (0, _v2.default)()
	  };
	}

	var columnAddedEventType = exports.columnAddedEventType = 'COLUMN_ADDED';
	function columnAddedEvent(params) {
	  var name = params.name,
	      position = params.position;

	  return {
	    type: columnAddedEventType,
	    data: {
	      id: (0, _v2.default)(),
	      name: name,
	      position: position,
	      createdAt: (0, _utils.currentTimestamp)()
	    },
	    id: (0, _v2.default)()
	  };
	}

	var columnUpdatedEventType = exports.columnUpdatedEventType = 'COLUMN_UPDATED';
	function columnUpdatedEvent(columnId, changes) {
	  return {
	    type: columnUpdatedEventType,
	    data: {
	      columnId: columnId,
	      changes: changes
	    },
	    id: (0, _v2.default)()
	  };
	}

	var columnRemovedEventType = exports.columnRemovedEventType = 'COLUMN_REMOVED';
	function columnRemovedEvent(columnId) {
	  return {
	    type: columnRemovedEventType,
	    data: {
	      columnId: columnId
	    },
	    id: (0, _v2.default)()
	  };
	}

	var commentAddedEventType = exports.commentAddedEventType = 'COMMENT_ADDED';
	function commentAddedEvent(cardId, params) {
	  var content = params.content,
	      attachmentName = params.attachmentName,
	      attachmentSize = params.attachmentSize,
	      attachmentType = params.attachmentType,
	      attachmentUrl = params.attachmentUrl,
	      authorId = params.authorId;


	  var attachment = null;
	  if (attachmentName) {
	    attachment = {
	      name: attachmentName,
	      size: attachmentSize,
	      type: attachmentType,
	      dataUrl: attachmentUrl
	    };
	  }

	  return {
	    type: commentAddedEventType,
	    data: {
	      id: (0, _v2.default)(),
	      cardId: cardId,
	      content: content,
	      attachment: attachment,
	      authorId: authorId,
	      createdAt: (0, _utils.currentTimestamp)()
	    },
	    id: (0, _v2.default)()
	  };
	}

	var commentUpdatedEventType = exports.commentUpdatedEventType = 'COMMENT_UPDATED';
	function commentUpdatedEvent(commentId, changes) {
	  return {
	    type: commentUpdatedEventType,
	    data: {
	      commentId: commentId,
	      changes: changes
	    },
	    id: (0, _v2.default)()
	  };
	}

	var commentRemovedEventType = exports.commentRemovedEventType = 'COMMENT_REMOVED';
	function commentRemovedEvent(commentId) {
	  return {
	    type: commentRemovedEventType,
	    data: { commentId: commentId },
	    id: (0, _v2.default)()
	  };
	}

	var fileAddedEventType = exports.fileAddedEventType = 'FILE_ADDED';
	function fileAddedEvent(filePath) {
	  return {
	    type: fileAddedEventType,
	    data: {
	      filePath: filePath,
	      createdAt: (0, _utils.currentTimestamp)()
	    },
	    id: (0, _v2.default)()
	  };
	}

	var fileRemovedEventType = exports.fileRemovedEventType = 'FILE_REMOVED';
	function fileRemovedEvent(filePath) {
	  return {
	    type: fileRemovedEventType,
	    data: {
	      filePath: filePath
	    },
	    id: (0, _v2.default)()
	  };
	}

	var settingsUpdatedEventType = exports.settingsUpdatedEventType = 'SETTINGS_UPDATED';
	function settingsUpdatedEvent(key, value) {
	  return {
	    type: settingsUpdatedEventType,
	    data: {
	      id: key,
	      value: value
	    },
	    id: (0, _v2.default)()
	  };
	}

	var userUpdatedEventType = exports.userUpdatedEventType = 'USER_UPDATED';
	function userUpdatedEvent(userId, key, value) {
	  return {
	    type: userUpdatedEventType,
	    data: {
	      id: userId,
	      key: key,
	      value: value
	    },
	    id: (0, _v2.default)()
	  };
	}

/***/ }),
/* 16 */
/***/ (function(module, exports, __webpack_require__) {

	'use strict';

	Object.defineProperty(exports, "__esModule", {
	  value: true
	});

	var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

	var _eventDefinitions = __webpack_require__(15);

	function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

	var CardsRepository = function () {
	  function CardsRepository(stateManager) {
	    _classCallCheck(this, CardsRepository);

	    this.stateManager = stateManager;
	  }

	  _createClass(CardsRepository, [{
	    key: 'get',
	    value: function get(id) {
	      var bucket = this.stateManager.bucket('cards');
	      return bucket.filter(function (c) {
	        return c.id === id;
	      })[0];
	    }
	  }, {
	    key: 'cardsSortedByPosition',
	    value: function cardsSortedByPosition(columnId) {
	      var bucket = this.stateManager.bucket('cards');
	      return bucket.filter(function (c) {
	        return c.columnId === columnId;
	      }).sort(function (c1, c2) {
	        return c1.position - c2.position;
	      });
	    }
	  }, {
	    key: 'addCard',
	    value: function addCard(title, columnId) {
	      var lastCard = this.cardsSortedByPosition(columnId).reverse()[0] || { position: -1 };
	      var lastPosition = lastCard.position + 1;

	      var event = (0, _eventDefinitions.cardAddedEvent)({
	        columnId: columnId,
	        position: lastPosition,
	        title: title
	      });
	      return this.stateManager.addEvent(event);
	    }
	  }, {
	    key: 'updateCard',
	    value: function updateCard(id, changes) {
	      var event = (0, _eventDefinitions.cardUpdatedEvent)(id, changes);
	      return this.stateManager.addEvent(event);
	    }
	  }, {
	    key: 'updateLabel',
	    value: function updateLabel(cardId, label, labelWillBeSet) {
	      var event = (0, _eventDefinitions.cardLabelUpdatedEvent)(cardId, label, labelWillBeSet);
	      return this.stateManager.addEvent(event);
	    }
	  }, {
	    key: 'removeCard',
	    value: function removeCard(cardId) {
	      var event = (0, _eventDefinitions.cardRemovedEvent)(cardId);
	      return this.stateManager.addEvent(event);
	    }
	  }]);

	  return CardsRepository;
	}();

	exports.default = CardsRepository;

/***/ }),
/* 17 */
/***/ (function(module, exports, __webpack_require__) {

	'use strict';

	Object.defineProperty(exports, "__esModule", {
	  value: true
	});

	var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

	var _settingsUpdated = __webpack_require__(18);

	var _settingsUpdated2 = _interopRequireDefault(_settingsUpdated);

	var _columnAdded = __webpack_require__(19);

	var _columnAdded2 = _interopRequireDefault(_columnAdded);

	var _columnUpdated = __webpack_require__(21);

	var _columnUpdated2 = _interopRequireDefault(_columnUpdated);

	var _columnRemoved = __webpack_require__(22);

	var _columnRemoved2 = _interopRequireDefault(_columnRemoved);

	var _cardAdded = __webpack_require__(25);

	var _cardAdded2 = _interopRequireDefault(_cardAdded);

	var _cardUpdated = __webpack_require__(26);

	var _cardUpdated2 = _interopRequireDefault(_cardUpdated);

	var _cardRemoved = __webpack_require__(23);

	var _cardRemoved2 = _interopRequireDefault(_cardRemoved);

	var _cardLabelUpdated = __webpack_require__(27);

	var _cardLabelUpdated2 = _interopRequireDefault(_cardLabelUpdated);

	var _commentAdded = __webpack_require__(28);

	var _commentAdded2 = _interopRequireDefault(_commentAdded);

	var _commentUpdated = __webpack_require__(29);

	var _commentUpdated2 = _interopRequireDefault(_commentUpdated);

	var _commentRemoved = __webpack_require__(30);

	var _commentRemoved2 = _interopRequireDefault(_commentRemoved);

	var _userUpdated = __webpack_require__(31);

	var _userUpdated2 = _interopRequireDefault(_userUpdated);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

	var CurrentState = function () {
	  function CurrentState(params) {
	    _classCallCheck(this, CurrentState);

	    this.eventStorage = params.eventSource;
	    this.userId = params.userId;
	    this.observers = [];
	    this.data = {};
	    this.eventHandlers = {};

	    this.registerEventHandlers([_settingsUpdated2.default, _columnAdded2.default, _columnUpdated2.default, _columnRemoved2.default, _cardAdded2.default, _cardUpdated2.default, _cardRemoved2.default, _cardLabelUpdated2.default, _commentAdded2.default, _commentUpdated2.default, _commentRemoved2.default, _userUpdated2.default]);

	    this.eventStorage.addObserver(this);
	    this.processAllPastEvents();
	  }

	  _createClass(CurrentState, [{
	    key: 'addObserver',
	    value: function addObserver(observer) {
	      this.observers.push(observer);
	    }
	  }, {
	    key: 'purge',
	    value: function purge() {
	      var _this = this;

	      this.eventStorage.purge().then(function () {
	        _this.data = {};
	        _this.onDataSynced();
	      });
	    }
	  }, {
	    key: 'addEvent',
	    value: function addEvent(event) {
	      return this.eventStorage.addEvent(event);
	    }
	  }, {
	    key: 'addFile',
	    value: function addFile(attr) {
	      return this.eventStorage.addFile(attr);
	    }
	  }, {
	    key: 'removeFile',
	    value: function removeFile(fileName) {
	      return this.eventStorage.removeFile(fileName);
	    }
	  }, {
	    key: 'getUserId',
	    value: function getUserId() {
	      return this.userId;
	    }

	    //
	    // this method is read only getter

	  }, {
	    key: 'bucket',
	    value: function bucket(bucketName) {
	      if (!this.data[bucketName]) {
	        this.data[bucketName] = [];
	      }
	      return this.data[bucketName].slice(0);
	    }
	  }, {
	    key: 'addObject',
	    value: function addObject(bucketName, object) {
	      if (!this.data[bucketName]) {
	        this.data[bucketName] = [];
	      }
	      this.data[bucketName].push(object);
	    }
	  }, {
	    key: 'updateObject',
	    value: function updateObject(bucketName, objectId, changes) {
	      var objectIndex = this.bucket(bucketName).findIndex(function (object) {
	        return object.id === objectId;
	      });
	      var oldData = this.bucket(bucketName)[objectIndex];
	      var updatedData = Object.assign(oldData, changes);
	      this.data[bucketName][objectIndex] = updatedData;
	    }
	  }, {
	    key: 'removeObject',
	    value: function removeObject(bucketName, objectId) {
	      var bucket = this.data[bucketName];
	      var objectIndex = bucket.findIndex(function (object) {
	        return object.id === objectId;
	      });
	      bucket.splice(objectIndex, 1);
	    }
	  }, {
	    key: 'objectData',
	    value: function objectData(bucketName, objectId) {
	      var objectIndex = this.bucket(bucketName).findIndex(function (object) {
	        return object.id === objectId;
	      });
	      return this.data[bucketName][objectIndex];
	    }

	    // private

	  }, {
	    key: 'onDataSynced',
	    value: function onDataSynced() {
	      this.observers.forEach(function (observer) {
	        observer.onStateUpdate();
	      });
	    }
	  }, {
	    key: 'processAllPastEvents',
	    value: function processAllPastEvents() {
	      var _this2 = this;

	      this.eventStorage.allPastEvents().then(function (events) {
	        events.forEach(function (event) {
	          _this2.onNewEvent(event, false);
	        });
	        _this2.onDataSynced();
	      });
	    }
	  }, {
	    key: 'registerEventHandlers',
	    value: function registerEventHandlers(arrayOfeventHandlerClasses) {
	      var _this3 = this;

	      arrayOfeventHandlerClasses.forEach(function (eh) {
	        _this3.eventHandlers[eh.forEvent()] = eh;
	      });
	    }

	    //
	    // eventSource callback

	  }, {
	    key: 'onNewEvent',
	    value: function onNewEvent(event) {
	      var notifyObservers = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;

	      var handlerName = event.type;
	      if (this.eventHandlers[handlerName]) {
	        new this.eventHandlers[handlerName](this).execute(event);

	        if (notifyObservers) {
	          this.onDataSynced();
	        }
	      }
	    }
	  }]);

	  return CurrentState;
	}();

	exports.default = CurrentState;

/***/ }),
/* 18 */
/***/ (function(module, exports, __webpack_require__) {

	'use strict';

	Object.defineProperty(exports, "__esModule", {
	  value: true
	});

	var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

	var _eventDefinitions = __webpack_require__(15);

	function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

	var SettingsUpdated = function () {
	  _createClass(SettingsUpdated, null, [{
	    key: 'forEvent',
	    value: function forEvent() {
	      return _eventDefinitions.settingsUpdatedEventType;
	    }
	  }]);

	  function SettingsUpdated(currentState) {
	    _classCallCheck(this, SettingsUpdated);

	    this.currentState = currentState;
	  }

	  _createClass(SettingsUpdated, [{
	    key: 'execute',
	    value: function execute(event) {
	      var data = event.data;
	      var settings = this.currentState.objectData('settings', data.id);
	      if (settings) {
	        this.currentState.removeObject('settings', data.id);
	      }

	      if (data.value) {
	        this.currentState.addObject('settings', event.data);
	      }
	    }
	  }]);

	  return SettingsUpdated;
	}();

	exports.default = SettingsUpdated;

/***/ }),
/* 19 */
/***/ (function(module, exports, __webpack_require__) {

	'use strict';

	Object.defineProperty(exports, "__esModule", {
	  value: true
	});

	var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

	var _eventDefinitions = __webpack_require__(15);

	var _repositionAllColumns = __webpack_require__(20);

	var _repositionAllColumns2 = _interopRequireDefault(_repositionAllColumns);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

	var ColumnAdded = function () {
	  _createClass(ColumnAdded, null, [{
	    key: 'forEvent',
	    value: function forEvent() {
	      return _eventDefinitions.columnAddedEventType;
	    }
	  }]);

	  function ColumnAdded(currentState) {
	    _classCallCheck(this, ColumnAdded);

	    this.currentState = currentState;
	  }

	  _createClass(ColumnAdded, [{
	    key: 'execute',
	    value: function execute(event) {
	      this.currentState.addObject('columns', event.data);
	      (0, _repositionAllColumns2.default)(this.currentState);
	    }
	  }]);

	  return ColumnAdded;
	}();

	exports.default = ColumnAdded;

/***/ }),
/* 20 */
/***/ (function(module, exports) {

	'use strict';

	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	exports.default = repositionAllColumns;

	function repositionAllColumns(currentState) {
	  currentState.bucket('columns').sort(function (c1, c2) {
	    return c1.position - c2.position;
	  }).forEach(function (c, i) {
	    currentState.updateObject('columns', c.id, { position: i });
	  });
	}

/***/ }),
/* 21 */
/***/ (function(module, exports, __webpack_require__) {

	'use strict';

	Object.defineProperty(exports, "__esModule", {
	  value: true
	});

	var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

	var _eventDefinitions = __webpack_require__(15);

	function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

	var ColumnUpdated = function () {
	  _createClass(ColumnUpdated, null, [{
	    key: 'forEvent',
	    value: function forEvent() {
	      return _eventDefinitions.columnUpdatedEventType;
	    }
	  }]);

	  function ColumnUpdated(currentState) {
	    _classCallCheck(this, ColumnUpdated);

	    this.currentState = currentState;
	  }

	  _createClass(ColumnUpdated, [{
	    key: 'execute',
	    value: function execute(event) {
	      var columnId = event.data.columnId;
	      var column = this.currentState.objectData('columns', columnId);
	      var changes = event.data.changes;
	      var newPosition = changes.position;

	      if (newPosition !== undefined) {
	        this.updatePositionOfOtherColumns(column, newPosition);
	      }

	      this.currentState.updateObject('columns', columnId, changes);
	    }

	    // private

	  }, {
	    key: 'updatePositionOfOtherColumns',
	    value: function updatePositionOfOtherColumns(movedColumn, newPosition) {
	      var _this = this;

	      var movedColumnId = movedColumn.id;
	      var oldPosition = movedColumn.position;
	      var columns = this.currentState.bucket('columns').filter(function (c) {
	        return c.id !== movedColumnId;
	      });

	      if (newPosition < oldPosition) {
	        // moving to left
	        // all after movedColumnId's newPosition: update position +1
	        columns.forEach(function (c) {
	          if (c.position >= newPosition && c.position < oldPosition) {
	            _this.currentState.updateObject('columns', c.id, { position: c.position + 1 });
	          }
	        });
	      } else {
	        // moving to right
	        // all before movedColumnId's newPosition: update position -1
	        columns.forEach(function (c) {
	          if (c.position <= newPosition && c.position > oldPosition) {
	            _this.currentState.updateObject('columns', c.id, { position: c.position - 1 });
	          }
	        });
	      }
	    }
	  }]);

	  return ColumnUpdated;
	}();

	exports.default = ColumnUpdated;

/***/ }),
/* 22 */
/***/ (function(module, exports, __webpack_require__) {

	'use strict';

	Object.defineProperty(exports, "__esModule", {
	  value: true
	});

	var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

	var _cardRemoved = __webpack_require__(23);

	var _cardRemoved2 = _interopRequireDefault(_cardRemoved);

	var _repositionAllColumns = __webpack_require__(20);

	var _repositionAllColumns2 = _interopRequireDefault(_repositionAllColumns);

	var _eventDefinitions = __webpack_require__(15);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

	var ColumnRemoved = function () {
	  _createClass(ColumnRemoved, null, [{
	    key: 'forEvent',
	    value: function forEvent() {
	      return _eventDefinitions.columnRemovedEventType;
	    }
	  }]);

	  function ColumnRemoved(currentState) {
	    _classCallCheck(this, ColumnRemoved);

	    this.currentState = currentState;
	  }

	  _createClass(ColumnRemoved, [{
	    key: 'execute',
	    value: function execute(event) {
	      var column = this.currentState.objectData('columns', event.data.columnId);
	      this.removeAllCards(column);
	      this.removeColumn(column);
	      (0, _repositionAllColumns2.default)(this.currentState);
	    }

	    // private

	  }, {
	    key: 'removeAllCards',
	    value: function removeAllCards(column) {
	      var cardRemovedEventHandler = new _cardRemoved2.default(this.currentState);
	      this.currentState.bucket('cards').forEach(function (card) {
	        if (card.columnId === column.id) {
	          var proxyEvent = (0, _eventDefinitions.cardRemovedEvent)(card.id);
	          cardRemovedEventHandler.execute(proxyEvent);
	        }
	      });
	    }
	  }, {
	    key: 'removeColumn',
	    value: function removeColumn(column) {
	      this.currentState.removeObject('columns', column.id);
	    }
	  }]);

	  return ColumnRemoved;
	}();

	exports.default = ColumnRemoved;

/***/ }),
/* 23 */
/***/ (function(module, exports, __webpack_require__) {

	'use strict';

	Object.defineProperty(exports, "__esModule", {
	  value: true
	});

	var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

	var _eventDefinitions = __webpack_require__(15);

	var _repositionAllCards = __webpack_require__(24);

	var _repositionAllCards2 = _interopRequireDefault(_repositionAllCards);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

	var CardRemoved = function () {
	  _createClass(CardRemoved, null, [{
	    key: 'forEvent',
	    value: function forEvent() {
	      return _eventDefinitions.cardRemovedEventType;
	    }
	  }]);

	  function CardRemoved(currentState) {
	    _classCallCheck(this, CardRemoved);

	    this.currentState = currentState;
	  }

	  _createClass(CardRemoved, [{
	    key: 'execute',
	    value: function execute(event) {
	      var card = this.currentState.objectData('cards', event.data.cardId);
	      this.removeComments(card);
	      this.removeCard(card);
	      this.repositionOtherCards(card);
	    }

	    // private

	  }, {
	    key: 'removeComments',
	    value: function removeComments(card) {
	      var commentsBucket = this.currentState.bucket('comments');
	      commentsBucket.forEach(function (comment, commentIndex) {
	        if (comment.cardId === card.id) {
	          commentsBucket.splice(commentIndex, 1);
	        }
	      });
	    }
	  }, {
	    key: 'removeCard',
	    value: function removeCard(card) {
	      this.currentState.removeObject('cards', card.id);
	    }
	  }, {
	    key: 'repositionOtherCards',
	    value: function repositionOtherCards(card) {
	      (0, _repositionAllCards2.default)(this.currentState, card.columnId);
	    }
	  }]);

	  return CardRemoved;
	}();

	exports.default = CardRemoved;

/***/ }),
/* 24 */
/***/ (function(module, exports) {

	'use strict';

	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	exports.default = repositionAllCards;

	function repositionAllCards(currentState, columnId) {
	  currentState.bucket('cards').filter(function (c) {
	    return c.columnId === columnId;
	  }).sort(function (c1, c2) {
	    return c1.position - c2.position;
	  }).forEach(function (c, i) {
	    currentState.updateObject('cards', c.id, { position: i });
	  });
	}

/***/ }),
/* 25 */
/***/ (function(module, exports, __webpack_require__) {

	'use strict';

	Object.defineProperty(exports, "__esModule", {
	  value: true
	});

	var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

	var _repositionAllCards = __webpack_require__(24);

	var _repositionAllCards2 = _interopRequireDefault(_repositionAllCards);

	var _eventDefinitions = __webpack_require__(15);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

	var CardAdded = function () {
	  _createClass(CardAdded, null, [{
	    key: 'forEvent',
	    value: function forEvent() {
	      return _eventDefinitions.cardAddedEventType;
	    }
	  }]);

	  function CardAdded(currentState) {
	    _classCallCheck(this, CardAdded);

	    this.currentState = currentState;
	  }

	  _createClass(CardAdded, [{
	    key: 'execute',
	    value: function execute(event) {
	      var card = event.data;
	      this.currentState.addObject('cards', card);
	      (0, _repositionAllCards2.default)(this.currentState, card.columnId);
	    }
	  }]);

	  return CardAdded;
	}();

	exports.default = CardAdded;

/***/ }),
/* 26 */
/***/ (function(module, exports, __webpack_require__) {

	'use strict';

	Object.defineProperty(exports, "__esModule", {
	  value: true
	});

	var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

	var _eventDefinitions = __webpack_require__(15);

	var _repositionAllCards = __webpack_require__(24);

	var _repositionAllCards2 = _interopRequireDefault(_repositionAllCards);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

	var CardUpdated = function () {
	  _createClass(CardUpdated, null, [{
	    key: 'forEvent',
	    value: function forEvent() {
	      return _eventDefinitions.cardUpdatedEventType;
	    }
	  }]);

	  function CardUpdated(currentState) {
	    _classCallCheck(this, CardUpdated);

	    this.currentState = currentState;
	  }

	  _createClass(CardUpdated, [{
	    key: 'execute',
	    value: function execute(event) {
	      var cardId = event.data.cardId;
	      var changes = event.data.changes;
	      var newPosition = changes.position;
	      var newColumnId = changes.columnId;

	      if (newPosition !== undefined || newColumnId !== undefined) {
	        var oldData = this.currentState.objectData('cards', cardId);
	        newPosition = newPosition !== undefined ? newPosition : oldData.position;
	        newColumnId = newColumnId !== undefined ? newColumnId : oldData.columnId;

	        this.updatePositionOfOtherCards(cardId, {
	          oldPosition: oldData.position,
	          newPosition: newPosition,
	          oldColumnId: oldData.columnId,
	          newColumnId: newColumnId
	        });
	      }

	      this.currentState.updateObject('cards', cardId, changes);
	    }

	    // private

	  }, {
	    key: 'updatePositionOfOtherCards',
	    value: function updatePositionOfOtherCards(movedCardId, params) {
	      var _this = this;

	      var oldPosition = params.oldPosition,
	          newPosition = params.newPosition,
	          oldColumnId = params.oldColumnId,
	          newColumnId = params.newColumnId;


	      var cards = this.currentState.bucket('cards').filter(function (c) {
	        return c.columnId === newColumnId && c.id !== movedCardId;
	      });

	      if (newColumnId === oldColumnId) {
	        //
	        // Move a card within same column
	        if (newPosition < oldPosition) {
	          // Moving a card up
	          // All cards after movedCardId's newPosition: update position +1
	          cards.forEach(function (c) {
	            if (c.position >= newPosition && c.position < oldPosition) {
	              _this.currentState.updateObject('cards', c.id, { position: c.position + 1 });
	            }
	          });
	        } else {
	          // Moving a card down
	          // All cards before movedCardId's newPosition: update position -1
	          cards.forEach(function (c) {
	            if (c.position <= newPosition && c.position > oldPosition) {
	              _this.currentState.updateObject('cards', c.id, { position: c.position - 1 });
	            }
	          });
	        }
	      } else {
	        //
	        // Move a card to a different column
	        // All cards in a new column, after movedCardId's newPosition: update position +1
	        cards.forEach(function (c) {
	          if (c.position >= newPosition) {
	            _this.currentState.updateObject('cards', c.id, { position: c.position + 1 });
	          }
	        });

	        // All cards in an old column, update like the moved card was removed
	        (0, _repositionAllCards2.default)(this.currentState, oldColumnId);
	      }
	    }
	  }]);

	  return CardUpdated;
	}();

	exports.default = CardUpdated;

/***/ }),
/* 27 */
/***/ (function(module, exports, __webpack_require__) {

	'use strict';

	Object.defineProperty(exports, "__esModule", {
	  value: true
	});

	var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

	var _eventDefinitions = __webpack_require__(15);

	function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

	var CardLabelUpdated = function () {
	  _createClass(CardLabelUpdated, null, [{
	    key: 'forEvent',
	    value: function forEvent() {
	      return _eventDefinitions.cardLabelUpdatedEventType;
	    }
	  }]);

	  function CardLabelUpdated(currentState) {
	    _classCallCheck(this, CardLabelUpdated);

	    this.currentState = currentState;
	  }

	  _createClass(CardLabelUpdated, [{
	    key: 'execute',
	    value: function execute(event) {
	      var cardId = event.data.cardId;
	      var label = event.data.label;
	      var shouldBeSet = event.data.set;
	      var card = this.currentState.objectData('cards', cardId);
	      var labels = card.labels || [];

	      if (shouldBeSet) {
	        labels.push(label);
	      } else {
	        var existedLabelIndex = labels.indexOf(label);
	        if (existedLabelIndex !== -1) {
	          labels.splice(existedLabelIndex, 1);
	        }
	      }
	      this.currentState.updateObject('cards', cardId, { labels: labels });
	    }
	  }]);

	  return CardLabelUpdated;
	}();

	exports.default = CardLabelUpdated;

/***/ }),
/* 28 */
/***/ (function(module, exports, __webpack_require__) {

	'use strict';

	Object.defineProperty(exports, "__esModule", {
	  value: true
	});

	var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

	var _eventDefinitions = __webpack_require__(15);

	function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

	var CommentAdded = function () {
	  _createClass(CommentAdded, null, [{
	    key: 'forEvent',
	    value: function forEvent() {
	      return _eventDefinitions.commentAddedEventType;
	    }
	  }]);

	  function CommentAdded(currentState) {
	    _classCallCheck(this, CommentAdded);

	    this.currentState = currentState;
	  }

	  _createClass(CommentAdded, [{
	    key: 'execute',
	    value: function execute(event) {
	      this.currentState.addObject('comments', event.data);
	    }
	  }]);

	  return CommentAdded;
	}();

	exports.default = CommentAdded;

/***/ }),
/* 29 */
/***/ (function(module, exports, __webpack_require__) {

	'use strict';

	Object.defineProperty(exports, "__esModule", {
	  value: true
	});

	var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

	var _eventDefinitions = __webpack_require__(15);

	function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

	var CommentUpdated = function () {
	  _createClass(CommentUpdated, null, [{
	    key: 'forEvent',
	    value: function forEvent() {
	      return _eventDefinitions.commentUpdatedEventType;
	    }
	  }]);

	  function CommentUpdated(currentState) {
	    _classCallCheck(this, CommentUpdated);

	    this.currentState = currentState;
	  }

	  _createClass(CommentUpdated, [{
	    key: 'execute',
	    value: function execute(event) {
	      var commentId = event.data.commentId;
	      var changes = event.data.changes;
	      this.currentState.updateObject('comments', commentId, changes);
	    }
	  }]);

	  return CommentUpdated;
	}();

	exports.default = CommentUpdated;

/***/ }),
/* 30 */
/***/ (function(module, exports, __webpack_require__) {

	'use strict';

	Object.defineProperty(exports, "__esModule", {
	  value: true
	});

	var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

	var _eventDefinitions = __webpack_require__(15);

	function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

	var CommentRemoved = function () {
	  _createClass(CommentRemoved, null, [{
	    key: 'forEvent',
	    value: function forEvent() {
	      return _eventDefinitions.commentRemovedEventType;
	    }
	  }]);

	  function CommentRemoved(currentState) {
	    _classCallCheck(this, CommentRemoved);

	    this.currentState = currentState;
	  }

	  _createClass(CommentRemoved, [{
	    key: 'execute',
	    value: function execute(event) {
	      var commentId = event.data.commentId;
	      this.currentState.removeObject('comments', commentId);
	    }
	  }]);

	  return CommentRemoved;
	}();

	exports.default = CommentRemoved;

/***/ }),
/* 31 */
/***/ (function(module, exports, __webpack_require__) {

	'use strict';

	Object.defineProperty(exports, "__esModule", {
	  value: true
	});

	var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

	var _eventDefinitions = __webpack_require__(15);

	function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

	var UserUpdated = function () {
	  _createClass(UserUpdated, null, [{
	    key: 'forEvent',
	    value: function forEvent() {
	      return _eventDefinitions.userUpdatedEventType;
	    }
	  }]);

	  function UserUpdated(currentState) {
	    _classCallCheck(this, UserUpdated);

	    this.currentState = currentState;
	  }

	  _createClass(UserUpdated, [{
	    key: 'execute',
	    value: function execute(event) {
	      var data = event.data;
	      var existedUser = this.currentState.objectData('users', data.id);
	      var userData = existedUser || {};

	      userData[data.key] = data.value;
	      userData.id = data.id;

	      if (existedUser) {
	        this.currentState.updateObject('users', data.id, userData);
	      } else {
	        this.currentState.addObject('users', userData);
	      }
	    }
	  }]);

	  return UserUpdated;
	}();

	exports.default = UserUpdated;

/***/ }),
/* 32 */
/***/ (function(module, exports) {

	'use strict';

	Object.defineProperty(exports, "__esModule", {
	  value: true
	});

	var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

	function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

	var AllowEveryoneAuth = function () {
	  function AllowEveryoneAuth() {
	    _classCallCheck(this, AllowEveryoneAuth);
	  }

	  _createClass(AllowEveryoneAuth, [{
	    key: 'welcomeInfo',
	    value: function welcomeInfo() {
	      return 'Auth: allow everyone';
	    }
	  }, {
	    key: 'grantAccessWithCredentials',
	    value: function grantAccessWithCredentials(email, _password) {
	      return Promise.resolve({
	        userId: email,
	        token: 'AllowEveryoneToken'
	      });
	    }
	  }, {
	    key: 'grantAccess',
	    value: function grantAccess(_token) {
	      return Promise.resolve();
	    }
	  }, {
	    key: 'allowEvent',
	    value: function allowEvent(_event, _token) {
	      return Promise.resolve();
	    }
	  }]);

	  return AllowEveryoneAuth;
	}();

	exports.default = AllowEveryoneAuth;

/***/ }),
/* 33 */
/***/ (function(module, exports) {

	"use strict";

	Object.defineProperty(exports, "__esModule", {
	  value: true
	});

	var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

	function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

	var NullLogger = function () {
	  function NullLogger() {
	    _classCallCheck(this, NullLogger);
	  }

	  _createClass(NullLogger, [{
	    key: "log",
	    value: function log() {}
	  }]);

	  return NullLogger;
	}();

	exports.default = NullLogger;

/***/ }),
/* 34 */
/***/ (function(module, exports, __webpack_require__) {

	'use strict';

	Object.defineProperty(exports, "__esModule", {
	  value: true
	});

	var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

	var _mkdirp = __webpack_require__(35);

	var _mkdirp2 = _interopRequireDefault(_mkdirp);

	var _child_process = __webpack_require__(36);

	var _eventDefinitions = __webpack_require__(15);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

	var swallowErrors = function swallowErrors() {};

	var GitEventStorage = function () {
	  function GitEventStorage(params) {
	    _classCallCheck(this, GitEventStorage);

	    this.remoteRepoUrl = params.remoteRepoUrl;
	    this.pathToSshPrivateKey = params.pathToSshPrivateKey;
	    this.commiterUsername = params.commiterUsername || 'Starboard BOT';
	    this.commiterEmail = params.commiterEmail || 'starboardbot@localhost';
	    this.dataBranchName = params.dataBranchName || '__starboard-data';
	    this.pathToTempLocalRepo = params.pathToTempLocalRepo || '.tmp/tmpRepo/'; // path HAS to end with /
	    this.syncingInterval = params.syncingInterval || 30;
	    this.logger = params.logger || { log: function log() {} };

	    this.observers = [];
	    this.lastSyncedCommit = undefined;
	    this.eventIdsSinceLastSync = [];
	    this.queue = Promise.resolve();

	    _mkdirp2.default.sync(this.pathToTempLocalRepo);
	    this.start();
	  }

	  _createClass(GitEventStorage, [{
	    key: 'welcomeInfo',
	    value: function welcomeInfo() {
	      return 'Source repo set to: ' + this.remoteRepoUrl;
	    }
	  }, {
	    key: 'addObserver',
	    value: function addObserver(observer) {
	      this.observers.push(observer);
	    }
	  }, {
	    key: 'addEvent',
	    value: function addEvent(event) {
	      var _this = this;

	      return new Promise(function (resolve, _reject) {
	        _this.queue = _this.queue.then(function () {
	          return _this.applyEvent(event);
	        }).then(resolve);
	      });
	    }
	  }, {
	    key: 'addFile',
	    value: function addFile(fileNameInGitFolder) {
	      var _this2 = this;

	      return new Promise(function (resolve, _reject) {
	        var event = (0, _eventDefinitions.fileAddedEvent)(fileNameInGitFolder);
	        _this2.queue = _this2.queue.then(function () {
	          return _this2.gitAddFile(fileNameInGitFolder);
	        }).then(function () {
	          return _this2.applyEvent(event);
	        }).then(function () {
	          resolve(fileNameInGitFolder);
	        });
	      });
	    }
	  }, {
	    key: 'removeFile',
	    value: function removeFile(fileNameInGitFolder) {
	      var _this3 = this;

	      return new Promise(function (resolve, _reject) {
	        var event = (0, _eventDefinitions.fileRemovedEvent)(fileNameInGitFolder);
	        _this3.queue = _this3.queue.then(function () {
	          return _this3.gitRemoveFile(fileNameInGitFolder);
	        }).then(function () {
	          return _this3.applyEvent(event);
	        }).then(function () {
	          resolve(fileNameInGitFolder);
	        });
	      });
	    }
	  }, {
	    key: 'allPastEvents',
	    value: function allPastEvents() {
	      var _this4 = this;

	      return new Promise(function (resolve, _reject) {
	        _this4.queue = _this4.queue.then(_this4.gitGetAllCommitMessages.bind(_this4)).then(_this4.extractEventsFromCommits.bind(_this4)).then(resolve);
	      });
	    }

	    // private

	  }, {
	    key: 'configureGitPrivateKeyIfNeeded',
	    value: function configureGitPrivateKeyIfNeeded() {
	      if (!this.pathToSshPrivateKey) return;
	      //
	      // taken from:
	      // https://superuser.com/a/912281
	      process.env.GIT_SSH_COMMAND = 'ssh -i ' + this.pathToSshPrivateKey + ' -F /dev/null';
	    }
	  }, {
	    key: 'start',
	    value: function start() {
	      this.configureGitPrivateKeyIfNeeded();

	      this.queue = this.queue.then(this.setupLocalRepo.bind(this));

	      this.syncingLoopTimer = this.startPollingLoop(this.syncingInterval);
	    }
	  }, {
	    key: 'setupLocalRepo',
	    value: function setupLocalRepo() {
	      return this.gitInitRepo().then(this.gitAddUser.bind(this)).then(this.gitAddRemote.bind(this)).then(this.setupLocalAndRemoteBranch.bind(this));
	    }
	  }, {
	    key: 'setupLocalAndRemoteBranch',
	    value: function setupLocalAndRemoteBranch() {
	      return this.gitCreateDataBranch().then(this.gitPullChanges.bind(this)).catch(this.gitPushEmptySetupCommit.bind(this));
	    }
	  }, {
	    key: 'notify',
	    value: function notify(event) {
	      this.observers.forEach(function (observer) {
	        observer.onNewEvent(event);
	      });
	    }
	  }, {
	    key: 'sync',
	    value: function sync() {
	      var _this5 = this;

	      return new Promise(function (resolve, _reject) {
	        _this5.queue = _this5.queue.then(_this5.gitPushChangesWithEventualRebase.bind(_this5) // Push With Eventual Rebase will
	        // fetch data also whenever clear push
	        // is rejected.
	        // After rebase some old events
	        // will reappear again, however those events
	        // wont be applied again because of
	        // eventIdsSinceLastSync guarding mechanism
	        // It handles both scenarios where there
	        // is something new on remote or on local.
	        ).then(_this5.gatherUnsyncedEvents.bind(_this5)).then(_this5.updateLastSyncedCommit.bind(_this5)).then(resolve);
	      });
	    }
	  }, {
	    key: 'applyEvent',
	    value: function applyEvent(event) {
	      var _this6 = this;

	      return this.gitCommit(JSON.stringify(event)).then(function () {
	        _this6.eventIdsSinceLastSync.push(event.id);
	      }).then(function () {
	        return _this6.notify(event);
	      });
	    }
	  }, {
	    key: 'gatherUnsyncedEvents',
	    value: function gatherUnsyncedEvents() {
	      var _this7 = this;

	      return this.gitCalculateDiffCommitMessages().then(this.extractEventsFromCommits.bind(this)).then(function (events) {
	        events.filter(function (event) {
	          return _this7.eventIdsSinceLastSync.indexOf(event.id) === -1;
	        }).forEach(function (event) {
	          _this7.notify(event);
	        });
	      });
	    }
	  }, {
	    key: 'extractEventsFromCommits',
	    value: function extractEventsFromCommits(textWithCommits) {
	      var messages = textWithCommits.split('\n' // separate commits
	      ).filter(function (e) {
	        return e;
	      } // remove empty strings
	      ).reverse(); // change order to earliest first

	      var events = messages.map(function (message) {
	        var extractedJson = message.split(' ').slice(1).join(' '); // remove commit hash from message
	        var event = JSON.parse(extractedJson);
	        return event;
	      });
	      return events;
	    }
	  }, {
	    key: 'updateLastSyncedCommit',
	    value: function updateLastSyncedCommit() {
	      var _this8 = this;

	      this.eventIdsSinceLastSync = [];
	      return this.gitCommitHash().then(function (hash) {
	        _this8.lastSyncedCommit = hash;
	      });
	    }
	  }, {
	    key: 'startPollingLoop',
	    value: function startPollingLoop(syncingInterval) {
	      var _this9 = this;

	      if (syncingInterval <= 0) return null;
	      this.sync();
	      return setInterval(function () {
	        _this9.sync();
	      }, syncingInterval * 1000);
	    }

	    // git commands

	  }, {
	    key: 'gitInitRepo',
	    value: function gitInitRepo() {
	      return this.execute('git init ' + this.pathToTempLocalRepo);
	    }
	  }, {
	    key: 'gitAddUser',
	    value: function gitAddUser() {
	      var _this10 = this;

	      return Promise.resolve().then(function () {
	        return _this10.execute('git -C ' + _this10.pathToTempLocalRepo + ' config user.name "' + _this10.commiterUsername + '"');
	      }).then(function () {
	        return _this10.execute('git -C ' + _this10.pathToTempLocalRepo + ' config user.email "' + _this10.commiterEmail + '"');
	      });
	    }
	  }, {
	    key: 'gitCreateDataBranch',
	    value: function gitCreateDataBranch() {
	      return this.execute('git -C ' + this.pathToTempLocalRepo + ' checkout -b ' + this.dataBranchName).catch(swallowErrors);
	    }
	  }, {
	    key: 'gitAddRemote',
	    value: function gitAddRemote() {
	      return this.execute('git -C ' + this.pathToTempLocalRepo + ' remote add origin ' + this.remoteRepoUrl).catch(swallowErrors);
	    }
	  }, {
	    key: 'gitCommitHash',
	    value: function gitCommitHash() {
	      return this.execute('git -C ' + this.pathToTempLocalRepo + ' rev-parse ' + this.dataBranchName);
	    }
	  }, {
	    key: 'gitCalculateDiffCommitMessages',
	    value: function gitCalculateDiffCommitMessages() {
	      if (this.lastSyncedCommit) {
	        return this.execute('git -C ' + this.pathToTempLocalRepo + ' log --oneline                            ' + this.lastSyncedCommit + '...' + this.dataBranchName);
	      }
	      return this.gitGetAllCommitMessages();
	    }
	  }, {
	    key: 'gitGetAllCommitMessages',
	    value: function gitGetAllCommitMessages() {
	      return this.execute('git -C ' + this.pathToTempLocalRepo + ' log --oneline ' + this.dataBranchName);
	    }
	  }, {
	    key: 'gitPullChanges',
	    value: function gitPullChanges() {
	      return this.execute('git -C ' + this.pathToTempLocalRepo + ' pull --rebase origin ' + this.dataBranchName);
	    }
	  }, {
	    key: 'gitPushChanges',
	    value: function gitPushChanges() {
	      return this.execute('git -C ' + this.pathToTempLocalRepo + ' push origin ' + this.dataBranchName);
	    }
	  }, {
	    key: 'gitAddFile',
	    value: function gitAddFile(filePath) {
	      return this.execute('git -C ' + this.pathToTempLocalRepo + ' add "' + filePath + '"');
	    }
	  }, {
	    key: 'gitRemoveFile',
	    value: function gitRemoveFile(filePath) {
	      return this.execute('git -C ' + this.pathToTempLocalRepo + ' rm "' + filePath + '"');
	    }
	  }, {
	    key: 'gitPushEmptySetupCommit',
	    value: function gitPushEmptySetupCommit() {
	      var event = (0, _eventDefinitions.noopEvent)();
	      return this.gitCommit(JSON.stringify(event)).then(this.gitPushChangesWithEventualRebase.bind(this));
	    }
	  }, {
	    key: 'gitPushChangesWithEventualRebase',
	    value: function gitPushChangesWithEventualRebase() {
	      var _this11 = this;

	      //
	      // try to push till it success,
	      // on fail: pull changes and try again
	      return this.gitPushChanges().catch(function () {
	        return _this11.gitPullChanges().then(_this11.gitPushChangesWithEventualRebase.bind(_this11));
	      });
	    }
	  }, {
	    key: 'gitCommit',
	    value: function gitCommit(message) {
	      var escapedMessage = message.replace(/'/g, '\'"\'"\''); // replace ' -> '"'"'
	      return this.execute('git -C ' + this.pathToTempLocalRepo + ' commit --allow-empty -m \'' + escapedMessage + '\'');
	    }
	  }, {
	    key: 'execute',
	    value: function execute(command) {
	      var _this12 = this;

	      return new Promise(function (resolve, reject) {
	        (0, _child_process.exec)(command, { env: process.env }, function (error, stdout, _stderr) {
	          _this12.logger.log(command);
	          if (error) {
	            return reject(error);
	          }
	          return resolve(stdout.trim());
	        });
	      });
	    }
	  }]);

	  return GitEventStorage;
	}();

	exports.default = GitEventStorage;

/***/ }),
/* 35 */
/***/ (function(module, exports) {

	module.exports = require("mkdirp");

/***/ }),
/* 36 */
/***/ (function(module, exports) {

	module.exports = require("child_process");

/***/ }),
/* 37 */
/***/ (function(module, exports, __webpack_require__) {

	'use strict';

	Object.defineProperty(exports, "__esModule", {
	  value: true
	});

	var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

	var _eventDefinitions = __webpack_require__(15);

	var _utils = __webpack_require__(12);

	function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

	var MemoryEventStorage = function () {
	  function MemoryEventStorage() {
	    var params = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

	    _classCallCheck(this, MemoryEventStorage);

	    this.addFileHandler = params.addFileHandler || (0, _utils.hasToBeSet)('addFileHandler');
	    this.logger = params.logger || { log: function log() {} };
	    this.events = [];
	    this.observers = [];
	  }

	  _createClass(MemoryEventStorage, [{
	    key: 'welcomeInfo',
	    value: function welcomeInfo() {
	      return 'Using Memory Storage';
	    }
	  }, {
	    key: 'addObserver',
	    value: function addObserver(observer) {
	      this.observers.push(observer);
	    }
	  }, {
	    key: 'addEvent',
	    value: function addEvent(event) {
	      var _this = this;

	      return new Promise(function (resolve, _reject) {
	        _this.events.push(event);
	        _this.notify(event);
	        _this.logger.log(event);
	        resolve();
	      });
	    }
	  }, {
	    key: 'addFile',
	    value: function addFile(fileBlobOrFilePath) {
	      var _this2 = this;

	      return this.addFileHandler(fileBlobOrFilePath).then(function (fileUrl) {
	        var event = (0, _eventDefinitions.fileAddedEvent)(fileUrl);
	        return _this2.addEvent(event).then(function () {
	          return fileUrl;
	        });
	      });
	    }
	  }, {
	    key: 'removeFile',
	    value: function removeFile(_fileName) {
	      // Do nothing... Files are stored directly in url (as base64)
	    }
	  }, {
	    key: 'allPastEvents',
	    value: function allPastEvents() {
	      return Promise.resolve(this.events);
	    }
	  }, {
	    key: 'purge',
	    value: function purge() {
	      this.events = [];
	      return Promise.resolve();
	    }

	    // private

	  }, {
	    key: 'notify',
	    value: function notify(event) {
	      this.observers.forEach(function (observer) {
	        observer.onNewEvent(event);
	      });
	    }
	  }]);

	  return MemoryEventStorage;
	}();

	exports.default = MemoryEventStorage;

/***/ }),
/* 38 */
/***/ (function(module, exports, __webpack_require__) {

	'use strict';

	Object.defineProperty(exports, "__esModule", {
	  value: true
	});

	var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

	var _memoryEventStorage = __webpack_require__(37);

	var _memoryEventStorage2 = _interopRequireDefault(_memoryEventStorage);

	var _frontendFilesHandler = __webpack_require__(39);

	var _frontendFilesHandler2 = _interopRequireDefault(_frontendFilesHandler);

	var _backendWithFilesStorageFilesHandler = __webpack_require__(40);

	var _backendWithFilesStorageFilesHandler2 = _interopRequireDefault(_backendWithFilesStorageFilesHandler);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

	var MemoryEventStorageFactory = function () {
	  function MemoryEventStorageFactory() {
	    _classCallCheck(this, MemoryEventStorageFactory);
	  }

	  _createClass(MemoryEventStorageFactory, [{
	    key: 'forFrontend',
	    value: function forFrontend(params) {
	      var attr = params || {};
	      return this.storageWithFileHander(_frontendFilesHandler2.default, attr.logger);
	    }
	  }, {
	    key: 'forBackendWithStoredFiles',
	    value: function forBackendWithStoredFiles(params) {
	      var attr = params || {};
	      return this.storageWithFileHander(_backendWithFilesStorageFilesHandler2.default, attr.logger);
	    }

	    // private

	  }, {
	    key: 'storageWithFileHander',
	    value: function storageWithFileHander(fileHandler, logger) {
	      return new _memoryEventStorage2.default({
	        logger: logger,
	        addFileHandler: fileHandler
	      });
	    }
	  }]);

	  return MemoryEventStorageFactory;
	}();

	exports.default = MemoryEventStorageFactory;

/***/ }),
/* 39 */
/***/ (function(module, exports) {

	'use strict';

	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	exports.default = frontendFilesHandler;
	function frontendFilesHandler(fileBlob) {
	  return new Promise(function (resolve, _reject) {
	    var reader = new FileReader();
	    reader.addEventListener('load', function () {
	      resolve(reader.result);
	    }, false);
	    reader.readAsDataURL(fileBlob);
	  });
	}

/***/ }),
/* 40 */
/***/ (function(module, exports) {

	"use strict";

	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	exports.default = backendWithFilesStorageFilesHandler;
	function backendWithFilesStorageFilesHandler(fileName) {
	  //
	  // do nothing. Files are already in public folder.
	  return Promise.resolve(fileName);
	}

/***/ }),
/* 41 */
/***/ (function(module, exports, __webpack_require__) {

	'use strict';

	Object.defineProperty(exports, "__esModule", {
	  value: true
	});

	var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

	var _axios = __webpack_require__(42);

	var _axios2 = _interopRequireDefault(_axios);

	var _socket = __webpack_require__(43);

	var _socket2 = _interopRequireDefault(_socket);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

	var ServerEventStorage = function () {
	  function ServerEventStorage() {
	    var params = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

	    _classCallCheck(this, ServerEventStorage);

	    var uri = params.uri || undefined; // same domain
	    this.token = params.token;
	    this.queue = Promise.resolve();
	    this.observers = [];
	    this.addedEventIDs = []; // To have smooth adding flow,
	    // we notify on success add,
	    // and ignore that event comming back
	    // from server (via newEvent channel)
	    this.socket = (0, _socket2.default)(uri, { query: 'token=' + this.token });

	    this.start();
	  }

	  _createClass(ServerEventStorage, [{
	    key: 'welcomeInfo',
	    value: function welcomeInfo() {
	      return 'Using SocketIO proxy Storage (' + this.socket.io.uri + ')';
	    }
	  }, {
	    key: 'addObserver',
	    value: function addObserver(observer) {
	      this.observers.push(observer);
	    }
	  }, {
	    key: 'addEvent',
	    value: function addEvent(event) {
	      var _this = this;

	      return new Promise(function (resolve, _reject) {
	        _this.addedEventIDs.push(event.id);
	        _this.socket.emit('addEvent', event, function () {
	          _this.notify(event);
	          resolve();
	        });
	      });
	    }
	  }, {
	    key: 'addFile',
	    value: function addFile(fileBlob) {
	      var data = new FormData();
	      data.append('attachment', fileBlob);
	      data.append('token', this.token);
	      return _axios2.default.post('/attachments/', data).then(function (response) {
	        return response.data.attachmentUrl;
	      });
	    }
	  }, {
	    key: 'removeFile',
	    value: function removeFile(_fileName) {
	      // Do nothing... Server will clear attachments.
	    }
	  }, {
	    key: 'allPastEvents',
	    value: function allPastEvents() {
	      var _this2 = this;

	      return new Promise(function (resolve, _reject) {
	        _this2.queue = _this2.queue.then(function () {
	          _this2.socket.emit('getAllPastEvents', resolve);
	        });
	      });
	    }

	    // private

	  }, {
	    key: 'start',
	    value: function start() {
	      var _this3 = this;

	      this.queue = this.queue.then(function () {
	        return new Promise(function (resolve, _reject) {
	          _this3.socket.on('accessGranted', function () {
	            _this3.startListeningForEvents();
	            resolve();
	          });
	        });
	      });
	    }
	  }, {
	    key: 'startListeningForEvents',
	    value: function startListeningForEvents() {
	      var _this4 = this;

	      this.socket.on('newEvent', function (event) {
	        _this4.onNewEventFromServer(event);
	      });
	    }
	  }, {
	    key: 'onNewEventFromServer',
	    value: function onNewEventFromServer(event) {
	      if (this.addedEventIDs.indexOf(event.id) === -1) {
	        this.notify(event);
	      }
	    }
	  }, {
	    key: 'notify',
	    value: function notify(event) {
	      this.observers.forEach(function (observer) {
	        observer.onNewEvent(event);
	      });
	    }
	  }]);

	  return ServerEventStorage;
	}();

	exports.default = ServerEventStorage;

/***/ }),
/* 42 */
/***/ (function(module, exports) {

	module.exports = require("axios");

/***/ }),
/* 43 */
/***/ (function(module, exports) {

	module.exports = require("socket.io-client");

/***/ }),
/* 44 */
/***/ (function(module, exports, __webpack_require__) {

	'use strict';

	Object.defineProperty(exports, "__esModule", {
	  value: true
	});

	var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

	var _eventDefinitions = __webpack_require__(15);

	function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

	var SettingsRepository = function () {
	  function SettingsRepository(stateManager) {
	    _classCallCheck(this, SettingsRepository);

	    this.stateManager = stateManager;
	  }

	  _createClass(SettingsRepository, [{
	    key: 'availableColorSpecs',
	    value: function availableColorSpecs() {
	      return {
	        '#00E6FF': { isDark: false },
	        '#3CB500': { isDark: true },
	        '#FAD900': { isDark: false },
	        '#FF9F19': { isDark: false },
	        '#EB4646': { isDark: true },
	        '#A632DB': { isDark: true },
	        '#0079BF': { isDark: true }
	      };
	    }
	  }, {
	    key: 'availableColors',
	    value: function availableColors() {
	      return Object.keys(this.availableColorSpecs());
	    }
	  }, {
	    key: 'isThemeColorDark',
	    value: function isThemeColorDark() {
	      var color = this.themeColor();
	      return this.availableColorSpecs()[color].isDark;
	    }
	  }, {
	    key: 'themeColor',
	    value: function themeColor() {
	      return this.get('themeColor', '#3CB500');
	    }
	  }, {
	    key: 'setThemeColor',
	    value: function setThemeColor(hexColor) {
	      return this.set('themeColor', hexColor);
	    }
	  }, {
	    key: 'boardName',
	    value: function boardName() {
	      return this.get('boardName', '');
	    }
	  }, {
	    key: 'setBoardName',
	    value: function setBoardName(name) {
	      return this.set('boardName', name);
	    }
	  }, {
	    key: 'textForLabel',
	    value: function textForLabel(color) {
	      var key = 'label-' + color;
	      return this.get(key, '');
	    }
	  }, {
	    key: 'setTextForLabel',
	    value: function setTextForLabel(color, value) {
	      var key = 'label-' + color;
	      return this.set(key, value);
	    }

	    // private

	  }, {
	    key: 'get',
	    value: function get(key, defautValue) {
	      var settings = this.stateManager.objectData('settings', key);
	      var nullSettings = { value: defautValue };
	      return (settings || nullSettings).value;
	    }
	  }, {
	    key: 'set',
	    value: function set(key, value) {
	      var event = (0, _eventDefinitions.settingsUpdatedEvent)(key, value);
	      return this.stateManager.addEvent(event);
	    }
	  }]);

	  return SettingsRepository;
	}();

	exports.default = SettingsRepository;

/***/ }),
/* 45 */
/***/ (function(module, exports, __webpack_require__) {

	'use strict';

	Object.defineProperty(exports, "__esModule", {
	  value: true
	});

	var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

	var _eventDefinitions = __webpack_require__(15);

	function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

	var ColumnsRepository = function () {
	  function ColumnsRepository(stateManager) {
	    _classCallCheck(this, ColumnsRepository);

	    this.stateManager = stateManager;
	  }

	  _createClass(ColumnsRepository, [{
	    key: 'get',
	    value: function get(columnId) {
	      var columns = this.stateManager.bucket('columns');
	      return columns.filter(function (column) {
	        return column.id === columnId;
	      })[0];
	    }
	  }, {
	    key: 'columnsSortedByPosition',
	    value: function columnsSortedByPosition() {
	      var columns = this.stateManager.bucket('columns');
	      return columns.sort(function (c1, c2) {
	        return c1.position - c2.position;
	      });
	    }
	  }, {
	    key: 'addColumn',
	    value: function addColumn(name) {
	      var lastColumn = this.columnsSortedByPosition().reverse()[0] || { position: -1 };
	      var lastPosition = lastColumn.position + 1;

	      var event = (0, _eventDefinitions.columnAddedEvent)({
	        name: name,
	        position: lastPosition
	      });
	      return this.stateManager.addEvent(event);
	    }
	  }, {
	    key: 'updateColumn',
	    value: function updateColumn(id, changes) {
	      var event = (0, _eventDefinitions.columnUpdatedEvent)(id, changes);
	      return this.stateManager.addEvent(event);
	    }
	  }, {
	    key: 'removeColumn',
	    value: function removeColumn(id) {
	      var event = (0, _eventDefinitions.columnRemovedEvent)(id);
	      return this.stateManager.addEvent(event);
	    }
	  }]);

	  return ColumnsRepository;
	}();

	exports.default = ColumnsRepository;

/***/ }),
/* 46 */
/***/ (function(module, exports, __webpack_require__) {

	'use strict';

	Object.defineProperty(exports, "__esModule", {
	  value: true
	});

	var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

	var _eventDefinitions = __webpack_require__(15);

	function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

	var UsersRepository = function () {
	  function UsersRepository(stateManager) {
	    _classCallCheck(this, UsersRepository);

	    this.stateManager = stateManager;
	  }

	  _createClass(UsersRepository, [{
	    key: 'currentUserId',
	    value: function currentUserId() {
	      return this.stateManager.getUserId();
	    }
	  }, {
	    key: 'currentUserNickname',
	    value: function currentUserNickname() {
	      var userId = this.currentUserId();
	      return this.userNickname(userId);
	    }
	  }, {
	    key: 'userNickname',
	    value: function userNickname(userId) {
	      var user = this.stateManager.objectData('users', userId);
	      return user && user.nickname;
	    }
	  }, {
	    key: 'setCurrentUserNickname',
	    value: function setCurrentUserNickname(nickname) {
	      var id = this.currentUserId();
	      var event = (0, _eventDefinitions.userUpdatedEvent)(id, 'nickname', nickname);
	      return this.stateManager.addEvent(event);
	    }
	  }, {
	    key: 'setUserNickname',
	    value: function setUserNickname(userId, nickname) {
	      var event = (0, _eventDefinitions.userUpdatedEvent)(userId, 'nickname', nickname);
	      return this.stateManager.addEvent(event);
	    }
	  }]);

	  return UsersRepository;
	}();

	exports.default = UsersRepository;

/***/ })
/******/ ])
});
;